# -*- coding: iso-8859-1 -*-
## ----------------------------------------------------------------------
## PyCoinCoin - Plug-in de changement de proxy
## ----------------------------------------------------------------------

import logging
log = logging.getLogger('pycc')
import sys
import os
from xmlrpclib import *
import threading


sys.path.append('..')
from coinlib.plugin import *
from cointklib.dialogs import *
from coinlib.utils import apply_styles
from coinlib.utils import UrlOpenerReset

def build_plugins(pycc):
  return { \
    'SwitchProxy': SwitchProxy(pycc, "SwitchProxy", "Change dynamiquement le proxy")
  }
class SwitchProxyOptions(OptionSet):
  
  def setName(self, name):
    self.name = "Switch Proxy"
    self.desc = """Configure la liste des proxys. 
    Chaque proxy doit tre la forme http://server1:port|user:password """
  
  def setObjects(self):
    self._objects = {  
      'proxy_list1': Option("Proxy 1", value="http://server1:port|user:password"),
      'proxy_list2': Option("Proxy 2", value="http://server2:port|user:password"),
      'proxy_list3': Option("Proxy 3", value="http://server3:port|user:password"),
      'proxy_list4': Option("Proxy 4", value="http://server4:port|user:password"),
      'proxy_list5': Option("Proxy 4", value="http://server5:port|user:password"),
      'proxy_list6': Option("Proxy 6", value="http://server6:port|user:password"),
      'toedit': Option("Editables", {"Gnral": ['proxy_list1','proxy_list2','proxy_list3',
          'proxy_list4','proxy_list5','proxy_list6']})
    }

class SwitchProxy(Plugin):
  def load_config(self):
    log.warning( "load config proxy" )
    self.options = SwitchProxyOptions(path=self.config_path)

  def config_frame(self, master):
    return OptionsEditor(master, self.options, self.pycc)

  def action_menu(self):
    log.debug( "ACTION proxy" )
    log.debug( self.options)
    proxys=['None']
    for key, val in self.options.val('toedit').items():
        for val2 in val:
            proxys.append(self.options.val(val2))
    SelectDialog(self.pycc.root, proxys, "Proxy Selector", 
            "Choisir le proxy actif", width=40, height=8)
    log.debug(self.pycc.root.selected)
    if self.pycc.root.selected == 'None':
        log.debug('Pas de proxy slectionn')
        self.pycc.options.set('http_proxy','')
    else:
        # on regarde s'il y a besoin d'authentification
        ind=self.pycc.root.selected.find('|')
        lst=[]
        log.debug(ind)
        if ind==-1:
            lst.append(self.pycc.root.selected)
            lst.append('')
        else:
            lst.append(self.pycc.root.selected[:ind])
            lst.append(self.pycc.root.selected[ind+1:])
        log.debug(lst)
        self.pycc.options.set('http_proxy',lst[0])
        self.pycc.options.set('http_proxy_auth',lst[1])

    UrlOpenerReset(self.pycc.options.val('http_proxy'))
