# -*- coding: iso-8859-1 -*-
## ----------------------------------------------------------------------
## PyCoinCoin - Plug-in Zoodvinseen
## ----------------------------------------------------------------------

import logging
log = logging.getLogger('pycc')
import sys
sys.path.append('..')
from coinlib.plugin import *
from coinlib.utils import *
from coinlib.persistants import Option, OptionSet
from cointklib.widgets import OptionsEditor
import os, os.path, re

def build_plugins(pycc):
  return { \
    'zoodvinseen': Zoodvinseen(pycc, "Zoodvinseen", "Agrmente le bouchot avec du son")
  }

class ZooOptions(OptionSet):
  
  def setName(self, name):
    self.name = "Zoodvinseen"
  
  def setObjects(self):
    self._objects = {  
      'bigornorc_file': Option("Fichier bigornorc", value=os.path.join("plugins", "bigornorc"), type=TYPE_FILE),
      'sound_rep': Option("Rpertoire de stockage des sons", value=os.path.join("plugins", "zoodvinssen")),
      'toedit': Option("Editables", {"Gnral": ['bigornorc_file', 'sound_rep']})
    }

class Zoodvinseen(Plugin):
  
  def load_config(self):
    self.options = ZooOptions(path=self.config_path)
  
  def action_menu(self):
    self.pycc.showConfig('cplug_zoodvinseen')
  
  def config_frame(self, master):
    return OptionsEditor(master, self.options, self.pycc)

  def process(self, bouchot, context=PINNI, post=None, *args, **kwargs):
    garmoufle = [post.login, post.message, post.info, str(post.id), post.time, "", ""]
    blop = open(self.options.val('bigornorc_file'), "r")
    lignes = blop.readlines()
    for ligne in lignes:
      if ligne[0] == '#':
        continue
      glou = ligne.split('\t')
      while(1):
        try:
          glou.remove('')
        except ValueError:
          break
      if len(glou) < 7:
        continue
      for i in range(7):
        prout = i
        if not re.match('.*'+glou[i]+'.*', garmoufle[i].lower()):
          break
      else:
        for arg in " ".join(glou[7:]).split():
          if arg[-4:] == ".wav":
            start = arg.rfind("/")
            sound_file = os.path.join(self.options.val('sound_rep'), arg[start+1:])
            play_sound(sound_file)
