# -*- coding: iso-8859-1 -*-
## ----------------------------------------------------------------------
## PyCoinCoin - Module ControlCenter
##   Interface du PyCoinCoin Control Center.
## ----------------------------------------------------------------------

from Tkinter import *
import tkMessageBox, tkSimpleDialog
import Pmw
import os.path, os

import sys
sys.path.append('..')

from constants import *
from cointklib.dialogs import *
from cointklib.basicwidgets import *
from cointklib.widgets import *
from cointklib.events import KeyEventsEditor, ClickEventsEditor, MenuEventsEditor, PostProcessorEditor
from coinlib.utils import *
from coinlib.persistants import *
from modules import pycc_modules
from wizards import BouchotConfigWizard

import logging
log = logging.getLogger('pycc')

class Pyc4Intro(Frame):
  
  def __init__(self, parent, cc):
    self.cc = cc
    Frame.__init__(self, parent)
    Label(self, text="pyc4: pyCoinCoin Control Center", font="Times 12 bold italic", background=COLOR_TITLE).pack(fill=X)
    fr = Frame(self)
    self.image = PhotoImage(file=os.path.join(cc.pycc.script_path, "pyc4.gif"))
    Label(fr, image=self.image).pack(side=LEFT)
    mytext="""Bienvenue dans pyc4.\nTous les paramtres du canard sont rglables au travers de cette interface unique.
    
Slectionnez une catgorie  gauche pour afficher le module de configuration correspondant.
Pyc4 vous souhaite un agrable moulage."""
    infos = Text(fr, wrap=WORD, cursor="arrow", background="#D0F0FF", relief=FLAT,
      bd=2, font="Helvetica 9", width=26, height=11)
    infos.pack(side=RIGHT, fill=X)
    infos.insert(END, mytext)
    infos.config(state=DISABLED)
    fr.pack()
    infosb = Text(self, wrap=WORD, cursor="arrow", foreground="#ee0000", background="#D0F0FF", relief=FLAT,
      bd=2, font="Helvetica 9", width=52, height=3)
    infosb.pack(fill=X, expand=1)
    infosb.insert(END, "Attention, lorsque vous slectionnez une nouvelle catgorie, les changements du module courant ne sont pas enregistrs,  moins de pralablement cliquer sur 'Appliquer'.")
    infosb.config(state=DISABLED)
    infosc = Text(self, wrap=WORD, cursor="arrow", background="#D0F0FF", relief=FLAT,
      bd=2, font="Helvetica 9", width=52, height=6)
    infosc.pack(fill=X, expand=1)
    infosc.tag_config("info", foreground="#000080")
    infosc.insert(END, "Rpertoire de config: ")
    infosc.insert(END, self.cc.pycc.config_path, "info")
    infosc.insert(END, "\nVersion pycc: ")
    infosc.insert(END, PYCC_VERSION, "info")
    infosc.insert(END, "\nPlate-forme: ")
    infosc.insert(END, os.name, "info")
    infosc.insert(END, "\nVersion python: ")
    infosc.insert(END, sys.version, "info")
    infosc.insert(END, "\nVersion Pmw: ")
    infosc.insert(END, Pmw.version(), "info")
    infosc.config(state=DISABLED)
  
  def apply(self):
    pass
  
class PluginIntro(Frame):
  
  def __init__(self, parent, cc):
    self.cc = cc
    Frame.__init__(self, parent)
    Label(self, text="Configuration des plug-ins", font="Helvetica 10 bold", background=COLOR_TITLE).pack(fill=X, padx=5)
    mytext = \
    """Les "plug-ins" sont de petits programmes qui s'intgrent  pyCoinCoin pour en tendre les bugs^W fonctionnalits.
Une utilisation courante des plug-ins est de transformer le texte des posts (dcodeur rot13, plopificateur, etc.), mais tout autre type d'action est galement possible.
Certains plug-ins possdent des paramtres configurables - vous avez tout loisir de les modifier ici.
    """
    infos = Text(self, wrap=WORD, cursor="arrow", background="#D0F0FF", relief=FLAT,
      bd=2, font="Helvetica 9", width=52, height=8)
    infos.pack(fill=X, padx=5)
    infos.insert(END, mytext)
    infos.config(state=DISABLED)
    Label(self, text="Actuellement\n%s\nplug-ins chargs" % len(self.cc.pycc.plugins)).pack()
  
  def apply(self):
    pass

class BouchotIntro(Frame):
  
  def __init__(self, parent, cc):
    self.cc = cc
    self.root = parent
    Frame.__init__(self, parent)
    Label(self, text="Da Pycc Bouchot Configurator", font="Helvetica 10 bold", background=COLOR_TITLE).pack(fill=X, padx=5)
    mytext = \
    """Un "bouchot", dans la terminologie PyCoinCoin, est associ  un unique site web.
Au niveau de l'interface, un bouchot actif correspondra  un onglet. A un bouchot donn, on adjoint un ou plusieurs "modules" donnant accs aux fonctionnalits du site telles que :
  - Tribune libre (un seul module de ce type par bouchot)
  - Feed RSS (pour monitorer des news, blogs...)
    """
    infos = Text(self, wrap=WORD, cursor="arrow", background="#D0F0FF", relief=FLAT,
      bd=2, font="Helvetica 9", width=52, height=8)
    infos.pack(fill=X, padx=5)
    infos.insert(END, mytext)
    infos.config(state=DISABLED)
    fr = Frame(self)
    Label(fr, text="Il y a actuellement\n%s\nbouchots configurs." % len(self.cc.pycc.bouchots)).pack(side=LEFT, fill=X)
    fr1 = Frame(fr)
    Button(fr1, text="Crer un nouveau bouchot...", command=self.new_bouchot).pack(fill=X)
    Button(fr1, text="Supprimer un bouchot...", command=self.del_bouchot).pack(fill=X)
    fr1.pack(side=RIGHT)
    fr.pack(fill=X, pady=6)
  
  def apply(self):
    pass
  
  def new_bouchot(self):
    BouchotConfigWizard(self.cc.pycc, self.root)
  
  def del_bouchot(self):
    self.selected = None
    blist = self.cc.pycc.bouchots.keys()
    SelectDialog(self, blist, "Supprimer un bouchot", \
      "Slectionnez le bouchot  supprimer", width=20, height=10)
    if self.selected is not None:
      self.cc.pycc.destroy_bouchot(self.selected)
      self.cc.tree.remove_child('cbou', self.selected)
      self.cc.tree.select('cbou')
      tkMessageBox.showinfo("PyCCCC", "Le bouchot '%s' a t dtruit (aarrrrgh)." % self.selected, parent=self.root)
  

class ModuleIntro(Frame):
  
  def __init__(self, parent, cc, bouchot):
    self.cc = cc
    self.bouchot = bouchot
    self.root = parent
    Frame.__init__(self, parent)
    Label(self, text="Modules disponibles", font="Helvetica 10 bold", background=COLOR_TITLE, justify=LEFT, anchor=W).pack(fill=X, padx=5)
    infos = Text(self, wrap=WORD, cursor="arrow", background="#D0F0FF", relief=FLAT,
      bd=2, font="Helvetica 9", width=52, height=3)
    infos.pack(fill=X, padx=5)
    infos.insert(END, "Si le bouchot est actif, vous pouvez cocher/dcocher la case pour activer/dsactiver le module (cliquer sur 'Appliquer' pour rendre effectifs les changements).")
    infos.config(state=DISABLED)
    self.w_mod = {}
    for modname, module in self.cc.pycc.bouchots[self.bouchot].modules.items():
      fr = Frame(self)
      self.w_mod[modname] = BoolField(fr, "%s: %s" % (modname, module.options.val('descr')), module.loaded)
      self.w_mod[modname].pack(side=LEFT)
      Button(fr, text="Dtruire...", command=lambda s=self, m=modname: s.del_module(m)).pack(side=RIGHT)
      fr.pack(padx=5, fill=X)
    Label(self, text=" ").pack()
    Label(self, text="Nouveau module", font="Helvetica 10 bold", background=COLOR_TITLE, justify=LEFT, anchor=W).pack(fill=X, padx=5)
    fr = Frame(self)
    fr1 = Frame(fr)
    self.w_name = TextField(fr1, "Nom du module", "")
    self.w_name.pack(anchor=W)
    typelist = {}
    for modtype, desc in pycc_modules.items():
      typelist[modtype] = desc[0]
    self.w_type = ComboField(fr1, "Type du module", typelist, 'tribune')
    self.w_type.pack(anchor=W)
    self.w_type.bind_onchange(self.update_info)
    fr1.pack(side=LEFT)
    Button(fr, text="Crer...", command=self.new_module).pack(side=RIGHT, fill=Y)
    fr.pack(padx=5, fill=X, expand=1)
    self.w_info = Text(self, wrap=WORD, cursor="arrow", background="#D0F0FF", relief=FLAT,
      bd=2, font="Helvetica 9", width=52, height=4)
    self.w_info.pack(padx=5, fill=X, expand=1)
    self.update_info()
  
  def update_info(self):
    type = self.w_type.get()
    self.w_info.config(state=NORMAL)
    self.w_info.delete(0.0, END)
    self.w_info.insert(END, pycc_modules[type][1])
    self.w_info.config(state=DISABLED)
  
  def del_module(self, name):
    if tkMessageBox.askyesno("Dtruire module", "Voulez-vous supprimer dfinitivement le module '%s' ?" % name, parent=self):
      self.cc.pycc.bouchots[self.bouchot].destroy_module(name)
      self.cc.tree.remove_child(self.bouchot+'_cmod', "%s_%s" % (self.bouchot, name))
      self.cc.tree.select(self.bouchot+'_cmod')
  
  def new_module(self):
    name = self.w_name.get()
    if not name:
      tkMessageBox.showwarning("Nouveau module", "Vous devez saisir un nom !", parent=self.root)
      self.w_name.focus_set()
      return
    cur_bouchot = self.cc.pycc.bouchots[self.bouchot]
    if name in cur_bouchot.modules.keys():
      tkMessageBox.showwarning("Nouveau module", "Impossible de crer '%s':\nun module de ce nom existe dj sur ce bouchot" % name, parent=self.root)
      self.w_name.focus_set()
      return
    type = self.w_type.get()
    if type == 'tribune':
      if cur_bouchot.modules.has_key(type):
        tkMessageBox.showwarning("Nouveau module", "Un module Tribune existe dj sur ce bouchot.\nUn bouchot ne peut grer qu'une tribune  la fois.\nSi le mme sereur hberge plusieurs tribunes, crez un autre bouchot.", parent=self.root)
        return
      if name != 'tribune':
        tkMessageBox.showwarning("Nouveau module", "Les modules de type Tribune doivent toujours porter le nom 'tribune'.\nLe module va tre renomm pour tre cr.", parent=self.root)
        name = 'tribune'
    cur_bouchot.new_module(name, type)
    cur_bouchot.load_module(name)
    self.cc.tree.add_child(self.bouchot+'_cmod', TreeStruct(CCSection("%s_%s" % (self.bouchot, name), name)))
    self.cc.tree.select("%s_%s" % (self.bouchot, name))
  
  def apply(self):
    for mod, widget in self.w_mod.items():
      cur_module = self.cc.pycc.bouchots[self.bouchot].modules[mod]
      if widget.get():
        if not cur_module.loaded:
          cur_module.initialize()
          cur_module.start()
      else:
        cur_module.quit()

class CCSection(object):
  def __init__(self, id, label, image=None):
    self.id = id
    self.label = label
    self.image = image
  

class ControlCenter(CoinTopLevel):
  
  generic_sections = [ ('cgen',   "Paramtres gnraux"), \
                       ('cident', "Identits"), \
                       ('cpalmi', "Palmipde Editor"), \
                       ('cpinni', "Pinnipde Teletype"), \
                       ('cbou',   "Bouchots"), \
                       ('cpp',    "Post-Processor"), \
                       ('cplug',  "Plug-ins"), \
                       ('cbot',   "Bots") ]
  
  bouchot_sections = [ ('clook', "Apparence"), \
                       ('cmod',  "Modules") ] #, \
                       # ('cplug', "Plug-ins") ]
  
  palmi_sections = [ ('celook', "Apparence"), \
                     ('cekeys', "Clavier") ]
  
  pinni_sections = [ ('cplook', "Apparence par dfaut"), \
                     ('cpkeys', "Clavier"), \
                     ('cpclic', "Souris"), \
                     ('cpmenu', "Menu contextuel") ]
  
  def __init__(self, parent, pycc, ini_page="root"):
    self.root = parent
    self.pycc = pycc
    # self.config_path = self.pycc.config_path
    self.ini_page = ini_page
    self.cur_frame = None
    
    self._tree = TreeStruct(CCSection("root", "PyCCCC"), self.build_sections(self.generic_sections))
    self._tree.findAll('cpalmi')[0].childs = self.build_sections(self.palmi_sections)
    self._tree.findAll('cpinni')[0].childs = self.build_sections(self.pinni_sections)
    self._tree.findAll('cplug')[0].childs = self.build_sections([("cplug_%s" % name, name) for name in self.pycc.plugins.keys()])
    
    tb = []
    for bouchal in get_available_bouchots(self.pycc.config_path):
      tb.append(TreeStruct(CCSection(bouchal, bouchal), [ TreeStruct(CCSection("%s_%s" % (bouchal, s[0]), s[1])) for s in self.bouchot_sections ]))
      # tb[-1].findAll(bouchal+'_cplug')[0].childs = [ TreeStruct(CCSection("%s_%s" % (bouchal, plugin), plugin)) for plugin in self.plugins ]
      tb[-1].findAll(bouchal+'_cmod')[0].childs = [ TreeStruct(CCSection("%s_%s" % (bouchal, module), module)) for module in get_modules(self.pycc.config_path, bouchal) ]
    self._tree.findAll('cbou')[0].childs = tb
    
    self._tree.collapseAll()
    CoinTopLevel.__init__(self, parent, "pyc4 - pyCoinCoin Control Center", [ BUT_OK, BUT_CANCEL, BUT_APPLY ])
    self.geometry("642x420")
  
  def build_sections(self, sections_list):
    return [ TreeStruct(CCSection(s[0], s[1])) for s in sections_list ]
  
  def new_bouchot_node(self, name):
    nbn = TreeStruct(CCSection(name, name), [ TreeStruct(CCSection("%s_%s" % (name, s[0]), s[1])) for s in self.bouchot_sections ])
    # nbn.findAll(name+'_cplug')[0].childs = [ TreeStruct(CCSection("%s_%s" % (name, plugin), plugin)) for plugin in self.plugins ]
    nbn.findAll(name+'_cmod')[0].childs = [ TreeStruct(CCSection("%s_%s" % (name, module), module)) for module in get_modules(self.pycc.config_path, name) ]
    return nbn
  
  def body(self, master):
    self.pw = Pmw.PanedWidget(master, orient='horizontal', hull_height=200)
    
    pane = self.pw.add("leftp", min=.1, size=.30)
    
    self.tree = Tree(pane, self._tree, width=20, height=15, wrap='none')
    self.tree.pack(expand=1, fill='both', side=LEFT)
    self.tree.bind_select(self.select)
    
    pane = self.pw.add("rightp", min=.1, size=.70)
    
    scfr = Pmw.ScrolledFrame(pane)
    scfr.pack(fill='both', expand=1)
    self.frame = scfr.interior()
    
    self.pw.pack(expand=1, fill='both')
    
    self.cur_widget = None
    self.tree.expand(self.ini_page)
    self.tree.select(self.ini_page)
  
  def apply(self):
    if self.cur_widget is not None:
      self.cur_widget.apply()
      self.pycc.apply_config(self.tree.selected)
  
  def select(self):
    theme_path = os.path.join(self.pycc.config_path, "themes")
    if self.cur_widget is not None:
      self.cur_widget.destroy()
      self.cur_widget = None
    
    #== Section racine
    if self.tree.selected == 'root':
      self.cur_widget = Pyc4Intro(self.frame, self)
    
    #== Sections gnrales
    elif self.tree.selected == 'cgen':
      opts = self.pycc.options
      self.cur_widget = OptionsEditor(self.frame, opts, extra_arg=self.pycc.config_path)
    elif self.tree.selected == 'cident':
      identities = self.pycc.identities
      self.cur_widget = IdentitiesEditor(self.frame, identities)
      tmplist = {}
      for name, bouchal in self.pycc.bouchots.items():
        tmplist[name] = bouchal.trib
      self.cur_widget.set_trib_list(tmplist)
    elif self.tree.selected == 'cpalmi':
      opts = self.pycc.palmi.options
      self.cur_widget = OptionsEditor(self.frame, opts)
    elif self.tree.selected == 'cpinni':
      pass # AFR
    elif self.tree.selected == 'cbou':
      self.cur_widget = BouchotIntro(self.frame, self)
    elif self.tree.selected == 'cpp':
      self.cur_widget = PostProcessorEditor(self.frame, self.pycc.processor, extra_arg=[BOT, self.pycc])
    elif self.tree.selected == 'cplug':
      self.cur_widget = PluginIntro(self.frame, self)
    elif self.tree.selected == 'cbot':
      pass # AFR
    
    #== Sections du pinnipde
    elif self.tree.selected == 'cplook':
      styles = self.pycc.default_styles
      self.cur_widget = ThemeEditor(self.frame, styles, theme_path, "pinni")
    elif self.tree.selected == 'cpkeys':
      keyset = self.pycc.pinni_keys
      self.cur_widget = KeyEventsEditor(self.frame, keyset, PINNI, self.pycc)
    elif self.tree.selected == 'cpclic':
      clickset = self.pycc.pinni_clicks
      self.cur_widget = ClickEventsEditor(self.frame, clickset, self.pycc)
    elif self.tree.selected == 'cpmenu':
      menuset = self.pycc.pinni_menu
      self.cur_widget = MenuEventsEditor(self.frame, menuset, self.pycc)
    
    #== Sections du palmipde
    elif self.tree.selected == 'celook':
      styles = self.pycc.palmi.styles
      self.cur_widget = ThemeEditor(self.frame, styles, theme_path, "palmi")
    elif self.tree.selected == 'cekeys':
      keyset = self.pycc.palmi.keys
      self.cur_widget = KeyEventsEditor(self.frame, keyset, PALMI, self.pycc)
    
    #== Sections des plug-ins
    elif self.tree.selected[:6] == "cplug_":
      plugin = self.tree.selected[6:]
      self.cur_widget = self.pycc.plugins[plugin].config_frame(self.frame)
      if self.cur_widget is None:
        self.cur_widget = Label(self.frame, text="Ce plug-in n'a pas d'options configurables")
        self.cur_widget.apply = self.nothing
    
    #== Sections spcifiques  chaque bouchot
    elif self.tree.selected.find("_") > 0:
      bouchal, section = self.tree.selected.split("_")
      if section == "clook":
        #if bouchal in self.pycc.bouchots:
        styles = self.pycc.bouchots[bouchal].styles
        #else:
        #  styles = PinniStyleSet(path=os.path.join(self.pycc.config_path, "bouchots", bouchal))
        self.cur_widget = ThemeEditor(self.frame, styles, theme_path, "pinni", 1, self.pycc.default_styles)
      elif section == "cmod":
        self.cur_widget = ModuleIntro(self.frame, self, bouchal)
        # self.cur_widget.apply = self.nothing
      #elif section == "cplug":
      #  pass
      else:
        # Ici on est sur un module spcifique
        cur_mod = self.pycc.bouchots[bouchal].modules[section]
        if not cur_mod.loaded:
          cur_mod.load_config()
        #opts = cur_mod.options
        #self.cur_widget = OptionsEditor(self.frame, opts, extra_arg=cur_mod.bouchot)
        self.cur_widget = cur_mod.config_frame(self.frame)
      
    #== Arriv ici, on doit logiquement tre sur le noeud racine d'un bouchot
    else:
      bouchal = self.tree.selected
      if bouchal in self.pycc.bouchots:
        opts = self.pycc.bouchots[bouchal].options
        self.mod_list = self.pycc.bouchots[bouchal].modules.keys()
      else:
        opts = BouchotOptions(path=os.path.join(self.pycc.config_path, "bouchots", bouchal))
        self.mod_list = get_modules(self.pycc.config_path, bouchal)
      self.cur_widget = OptionsEditor(self.frame, opts, extra_arg=self)
    
    if self.cur_widget is not None:
      self.cur_widget.pack(anchor=NW, fill=BOTH, expand=1)
  
  def nothing(self):
    print "-- pyc4:nothing"
  
  def cancel(self):
    self.pycc.pycccc = None
    CoinTopLevel.cancel(self)
  
  def quit(self):
    # -- AFR: confirmation pour enregistrer les modifs
    self.cancel()
  
