# -*- coding: iso-8859-1 -*-
## ----------------------------------------------------------------------
## PyCoinCoin - Module pyc4.help
##   Diffrents trucs pour l'aide, fentre About, toussa.
## ----------------------------------------------------------------------

import sys
sys.path.append('..')

from Tkinter import *
import tkMessageBox, tkSimpleDialog

from constants import *
from cointklib.dialogs import CoinDialog
from coinlib.utils import *

import logging
log = logging.getLogger('pycc')


class About(CoinDialog):
  """ Boite de dialogue A propos...
  """
  def __init__(self, pycc):
    self.pycc = pycc
    CoinDialog.__init__(self, pycc.root, "A propos de pyCoinCoin", [ BUT_CLOSE ], 1)
  
  def body(self, master):
    master.config(relief=GROOVE)
    Label(master, font="Helvetica 12 bold", background="#fcfcda", text="pyCoinCoin").pack(pady=5, fill=X)
    info_txt = "Genuine Tribune Mouling eXPerience with Python\n\nVersion %s\n\nby ChrisiX\n[ chrisix@free.fr ]" % PYCC_VERSION
    Label(master, text=info_txt).pack(pady=5, padx=5)
    self.version = Label(master, text="", font="Helvetica 10", foreground="#aa0000")
    self.version.pack()
    self.site = Label(master, text="http://chrisix.free.fr/pycoincoin/", font="Helvetica 9 bold", cursor="hand2", foreground="#000080", border=1)
    self.site.pack(pady=5)
    self.site.bind("<Enter>", self.hilight_site)
    self.site.bind("<Leave>", self.unhilight_site)
    self.site.bind("<ButtonRelease-1>", self.open_site)
    master.update_idletasks()
    master.after(200, self.get_last_version)
    return self.site
  
  def hilight_site(self, e):
    self.site.config(foreground="#0000ff", relief=SUNKEN)
  
  def unhilight_site(self, e):
    self.site.config(foreground="#000080", relief=FLAT)
  
  def open_site(self, e):
    self.pycc.openBrowser(self.site.cget("text"))
  
  def get_last_version(self):
    self.update_idletasks()
    try:
      f = open_url(AUTOCONFIG_SERVER, "/version.php", self.pycc.options)
      version = f.read().split("\n")[0]
      f.close()
    except:
      log.warning("Pas moyen de trouver la dernire version de pycc sur %s" % AUTOCONFIG_SERVER)
      return
    if version != PYCC_VERSION:
      self.version.config(text="Une nouvelle version (%s) est disponible" % version)
    self.update_idletasks()
  
